ScriptName AproposCommon Extends Quest
{SexLab specific utility functions}

SexLabFramework Property SexLab  Auto
slaUtilScr Property SlaUtil Auto

Int MALE = 0
Int FEMALE = 1

Import AproposUtil

Bool Function InMalePosition(SslThreadController thread, Actor anActor)    
    Int pos = thread.GetPosition(anActor)
    Return thread.Animation.MalePosition(pos)
EndFunction

Int Function GetIndexOfMalePosition(SslThreadController thread, Actor[] actorList)
    Int i = 0
    While i < actorList.Length
        Actor anActor = actorList[i]
        If InMalePosition(thread, anActor)
            Return i
        EndIf
        i += 1
    EndWhile
    Return -1
EndFunction

Int Function GetFactoredArousalIndex(Actor targeActor, Bool isRapist)
    ; Flesh out later for other factors, right now add 20 for rape.

    Int arousalValue = SlaUtil.GetActorArousal(targeActor)
    Int arousalIndex = GetArousalIndex(arousalValue)

    If isRapist
        Return arousalIndex + 20 ; boost during rape
    Else
        Return arousalIndex
    EndIf
EndFunction

Int Function GetArousalIndex(Int arousalValue)
    If arousalValue < 20
        Return 0
    ElseIf arousalValue >= 20 && arousalValue < 40
        Return 1
    ElseIf arousalValue >= 40 && arousalValue < 60
        Return 2
    ElseIf arousalValue >= 60 && arousalValue < 80
        Return 4
    ElseIf arousalValue >= 80
        Return 5
    EndIf
EndFunction

Bool Function IsGangBang(sslBaseAnimation animation)
    Return animation.HasTag("Gangbang")
EndFunction

Bool Function IsCreatureGangBang(sslBaseAnimation animation)
    Return IsThreeWayCreature(animation) || IsFourWayCreature(animation) || IsFiveWayCreature(animation)
EndFunction

Bool Function IsThreeWayCreature(sslBaseAnimation animation)
    Return animation.HasTag("CCF") || animation.HasTag("FCC")
EndFunction

Bool Function IsFourWayCreature(sslBaseAnimation animation)
    Return animation.HasTag("CCCF") || animation.HasTag("FCCC")
EndFunction

Bool Function IsFiveWayCreature(sslBaseAnimation animation)
    Return animation.HasTag("CCCCF") || animation.HasTag("FCCCC")
EndFunction

Bool Function IsGroupSex(sslBaseAnimation animation)
    Return TwoMales(animation) || TwoFemales(animation)
EndFunction

Bool Function TwoMales(sslBaseAnimation animation)
    Return animation.HasTag("MMF") || animation.HasTag("FMM")
EndFunction

String Function GetGangBangSpecifier(sslBaseAnimation animation) 
    ; Two Males
    If animation.HasTag("MMF") || animation.HasTag("FMM")
        Return "MMF"
    ; Three Males
    ElseIf animation.HasTag("MMMF") || animation.HasTag("FMMM")
        Return "MMMF"
    ; Four Males
    ElseIf animation.HasTag("MMMMF") || animation.HasTag("FMMMM")
        Return "MMMMF"
    ; Five Males
    ElseIf animation.HasTag("MMMMMF") || animation.HasTag("FMMMMM")
        Return "MMMMMF"
    ; Six Males
    ElseIf animation.HasTag("MMMMMMF") || animation.HasTag("FMMMMMM")
        Return "MMMMMMF"      
    Else
        Return ""  
    EndIf

EndFunction

Bool Function TwoFemales(sslBaseAnimation animation)
    Return animation.HasTag("MFF") || animation.HasTag("FFM")
EndFunction

Bool Function IsLesbianSex(SslBaseAnimation animation, Actor[] actorList)
    Int i = actorList.Length

    If i == 1
        Return False
    EndIf

    If animation.HasTag("FF")
        Return True
    EndIf    
    
    While i > 0
        i -= 1
        If SexLab.GetGender(actorList[i]) != FEMALE
            Return False
        EndIf
    EndWhile
    
    Return True
EndFunction

Bool Function IsGaySex(SslBaseAnimation animation, Actor[] actorList)
    Int i = actorList.Length

    If i == 1
        Return False
    EndIf

    If animation.HasTag("MM")
        Return True
    EndIf
    
    While (i > 0)
        i -= 1
        If SexLab.GetGender(actorList[i]) != MALE
            Return False
        EndIf
    EndWhile
    
    Return True
EndFunction

String[] Function BuildSexParts(Bool isVaginal, Bool isAnal, Bool isOral, Bool isBoobjob)
    If isVaginal && isAnal && isOral
        Return Strings("Vaginal", "Anal", "Oral")
    EndIf
    If isVaginal && isAnal
        Return Strings("Vaginal", "Anal")
    EndIf
    If isVaginal && isOral
        Return Strings("Vaginal", "Oral")
    EndIf
    If isAnal && isOral
        Return Strings("Anal", "Oral")
    EndIf
    If isVaginal && isBoobjob
        Return Strings("Vaginal", "Boobjob")
    EndIf
    If IsAnal && isBoobjob
        Return Strings("Anal", "Boobjob")
    EndIf
    If isBoobjob
        Return Strings("Boobjob")
    EndIf
    If isVaginal
        Return Strings("Vaginal")
    EndIf
    If isAnal
        Return Strings("Anal")
    EndIf
    If isOral
        Return Strings("Oral")
    EndIf
EndFunction

String[] Function GetSexPartsFromAnimation(SslBaseAnimation animation)
    Return BuildSexParts(animation.HasTag("Vaginal"), animation.HasTag("Anal"), animation.HasTag("Oral"), animation.HasTag("Boobjob"))
EndFunction

Bool Function IsDremora(Actor anActor)
    If anActor
        Race rc = anActor.GetRace()
        If rc
            String raceName = rc.GetName()
            ToUserLog(raceName)
            Bool dremora = StringContains(raceName, "dremora") || StringContains(raceName, "DremoraRace")
            return dremora
        EndIf
    EndIf
    Return False
EndFunction

String Function GetCreatureFromAnimation(SslBaseAnimation animation)
    If animation.HasTag("Wolf")
        Return "Wolf"
    ElseIf animation.HasTag("Bear")
        Return "Bear"
    ElseIf animation.HasTag("Chaurus")
        Return "Chaurus"
    ElseIf animation.HasTag("Daedra") || animation.HasTag("Seeker")
        Return "Daedra"
    ElseIf animation.HasTag("Canine")
        Return "Canine"
    ElseIf animation.HasTag("Dragon")
        Return "Dragon"
    ElseIf animation.HasTag("Draugr")
        Return "Draugr"
    ElseIf animation.HasTag("Falmer")
        Return "Falmer"
    ElseIf animation.HasTag("Gargoyle")
        Return "Gargoyle"
    ElseIf animation.HasTag("Giant")
        Return "Giant"
    ElseIf animation.HasTag("Horse")
        Return "Horse"
    ElseIf animation.HasTag("Cat") || animation.HasTag("SabreCat")
        Return "Cat"
    ElseIf animation.HasTag("Big Spider")
        Return "BigSpider"
    ElseIf animation.HasTag("Boar")
        Return "Boar"
    ElseIf animation.HasTag("Spider")
        Return "Spider"
    ElseIf animation.HasTag("Troll")
        Return "Troll"
    ElseIf animation.HasTag("Vampire Lord") || animation.HasTag("Vampirlord")
        Return "VampireLord"
    ElseIf animation.HasTag("Werewolf")
        Return "Werewolf"
    ElseIf animation.HasTag("Riekling")
        Return "Riekling"
    ElseIf animation.HasTag("Lurker") || animation.HasTag("Benthiclurker")
        Return "Lurker"
    ElseIf animation.HasTag("Netch")
        Return "Netch"
    ElseIf animation.HasTag("Horker")
        Return "Horker"
    ElseIf animation.HasTag("skeever") || animation.HasTag("Skeever")
        Return "Skeever"
    Else
        Return ""
    EndIf
EndFunction

Int Function MapWearTearAmountToState(Int amount)
    Int result = 0
    If amount < 38
        result = 1
    ElseIf amount >= 38 && amount < 57
        result = 2    
    ElseIf amount >= 57 && amount < 86
        result = 3        
    ElseIf amount >= 86 && amount < 129
        result = 4        
    ElseIf amount >= 129 && amount < 194
        result = 5        
    ElseIf amount >= 194 && amount < 291
        result = 6
    ElseIf amount >= 291 && amount < 437
        result = 7        
    ElseIf amount >= 437 && amount < 800
        result = 8
    ElseIf amount >= 800
        result = 9
    EndIf
    Return result
EndFunction 

Int Function MapWearTearStateToAmount(Int wtState)
    Int result = 0
    If wtState == 0
        result = 0
    ElseIf wtState == 1
        result = 37
    ElseIf wtState == 2
        result = 56
    ElseIf wtState == 3
        result = 85
    ElseIf wtState == 4
        result = 128
    ElseIf wtState == 5
        result = 193
    ElseIf wtState == 6
        result = 290
    ElseIf wtState == 7
        result = 436
    ElseIf wtState == 8
        result = 799
    Else
        result = 800
    EndIf
    Return result
EndFunction